<?php
class ControllerExtensionModuleSmsKaleyra extends Controller {
    
    
	private $model = 'model_module_smskaleyra';
	private $module_smskaleyra_path = 'module/smskaleyra';
	private $model_class = 'ModelModuleSmsKaleyra';
	private $model_app;
	private $sendsms;
	
	/**
	 * initialize OpenCart.
	 */	
	public function __construct($contructar){
	    parent::__construct($contructar);
		//cross version check and module
		if (version_compare(VERSION, '2.3.0.0', '>=')) {
			$this->model = 'model_extension_module_smskaleyra';
			$this->module_smskaleyra_path = 'extension/module/smskaleyra';
			$this->model_class = 'ModelExtensionModuleSmsKaleyra';
		}
 
		$this->load->model($this->module_smskaleyra_path);
		$this->load->model('setting/setting');
		$this->load->model('setting/store');
		$this->model_app = $this->{$this->model};
	}
	
//	Send SMS for new user is registered
	
	public function addCustomekaleyra() {
	    
	   if (func_num_args() > 1) {
	       $customer_id = !is_array(func_get_arg(1)) ? func_get_arg(1) : func_get_arg(2);
	    } else {
	        $customer_id = func_get_arg(0);
	    }
	   
	    
	    $this->load->model('setting/setting');	    
	    $dataSet = $this->model_setting_setting->getSetting('SMSkaleyra', $this->config->get('store_id'));
	    
	    if(strcmp(VERSION,"2.1.0.1") < 0) {
	        $this->load->library('smskaleyra');
	    }
	    if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey']))) {
	        $sendsms = new SmsKaleyra($dataSet['SMSkaleyra']['APIKey']);
	    }
	    
	    $language 		= $this->config->get('config_language_id');
	    //Send SMS to the admin when new user
	    if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['AdminRegister']['Enabled'] == 'yes')) {
	      
	        $customer = $this->model_app->DataCustomer($customer_id);
	        
	        if ($customer->row) {
	            $nameCustomer = $customer->row['firstname']." ".$customer->row['lastname'];
	        } else {
	            $nameCustomer = '';
	        }
	        
	        $original		= array("{SiteName}","{CustomerName}");
	        $replace		= array($this->config->get('config_name'), $nameCustomer);
	        
	        $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['AdminRegisterText']);
	        
	        if(is_array($message)) {
	            $message = implode("','",$message);
	        }
	        
	    	$from = '';	        
	        if (isset($dataSet['SMSkaleyra']['listsenderstore'])) {
	            $fromset = $dataSet['SMSkaleyra']['listsenderstore'];
	            foreach($fromset as $froms) {
	                $from = $froms;
	            }
	            
	        } 
	        $store_info = $this->model_setting_setting->getSetting('config', $this->config->get('store_id'));
	        $phone = $store_info['config_telephone'];
	        
	        
	        if(isset($dataSet['SMSkaleyra']['unicode-text-admin-on-register'][$language]) && $dataSet['SMSkaleyra']['unicode-text-admin-on-register'][$language] == 1){
	            $unicode = 1;
	        } else {
	            $unicode = 0;
	        }
	        var_dump($unicode);
	        $sendCheck = $this->model_app->CheckNumberCat($phone);
	            if (!empty($phone)) {
	                $resultreturn =  $sendsms->sendSMS(array(
	                    'SID' => $dataSet['SMSkaleyra']['SID'],
	                    'api-key' => $dataSet['SMSkaleyra']['APIKey'],
	                    'sender' => $from,
	                    'to' => $sendCheck,
	                    'body' => $message,
	 //                 'callback' => array($this->model_class, 'Callback')
	                    'type' => $dataSet['SMSkaleyra']['Type'],
	                    'unicode' => $unicode,
	                ));
	                
	                $this->Insertdb($resultreturn);
	            }
	        
	    }
	   
  
	    //Send SMS to the customer for registration it's ok
	    if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['CustomerRegister']['Enabled'] == 'yes')) {
	       
	        $customer = $this->model_app->DataCustomer($customer_id);
	        
	        if ($customer->row) {
	            $phone = $customer->row['telephone'];
	            $nameCustomer = $customer->row['firstname']." ".$customer->row['lastname'];
	        } else {
	            $phone = '';
	            $nameCustomer = '';
	        }
	        
	        
	        $original		= array("{StoreName}","{CustomerName}");
	        $replace		= array($this->config->get('config_name'), $nameCustomer);
	        
	        $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['CustomerRegisterText'][$language]);
	        
	        if(is_array($message)) {
	            $message = implode("','",$message);
	        }
	        
	        $sendCheck = $this->model_app->CheckNumberCat($phone);
	        $from = '';
	        
	        if (isset($dataSet['SMSkaleyra']['listsenderstore'])) {
	            $fromset = $dataSet['SMSkaleyra']['listsenderstore'];
	            foreach($fromset as $froms) {
	                $from = $froms;
	            }
	            	            
	        } 
	        
	        if(isset($dataSet['SMSkaleyra']['unicode-text-customer-register'][$language]) && $dataSet['SMSkaleyra']['unicode-text-customer-register'][$language] == 1){
	            $unicode = 1;
	        } else {
	            $unicode = 0;
	        }
	       
	        if ($sendCheck) {
	            $resultreturn =  $sendsms->sendSMS(array(
	                'SID' => $dataSet['SMSkaleyra']['SID'],
	                'sender' => $from,
	                'to' => $sendCheck,
	                'api-key' => $dataSet['SMSkaleyra']['APIKey'],
	                'body' => $message,
	   //           'callback' => array($this->model_class, 'Callback')
	                'type' => $dataSet['SMSkaleyra']['Type'],
	                'unicode' => $unicode,
	            ));
	            
	            $this->Insertdb($resultreturn);
	        }
	    }
	//    exit();

	}
	
	//Send SMS status order is changed
	
	public function addOrderHistorykaleyra($order_id, $route = '', $data = '') {
	   
	 	    
	    if (version_compare(VERSION, '2.2.0.0', ">=") && version_compare(VERSION, '2.3.0.0', "<")) {
	        $order_id = $data;
	    } else if(version_compare(VERSION, '2.3.0.0', ">=")){
	        $order_id = $route[0];
	    }
	    
	    
	    $this->load->model('checkout/order');
	    $order_info = $this->model_checkout_order->getOrder($order_id);
	    
	    $dataSet = $this->model_setting_setting->getSetting('SMSkaleyra', $order_info['store_id']);
	    
	    if(strcmp(VERSION,"2.1.0.1") < 0) {
	        $this->load->library('smskaleyra');
	    }
	    
	    if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey']))) {
	        $sendsms = new SmsKaleyra($dataSet['SMSkaleyra']['APIKey']);
	    }
	    
	    if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['OrderStatusChange']['Enabled'] == 'yes')) {
	        
	        $result = $this->model_app->OrderCoun($order_id);
	               
	        if ($order_info['order_status_id'] && $result->row['counter'] > 1 && (!empty($dataSet['SMSkaleyra']['OrderStatusChange']['OrderStatus']) && (in_array($order_info['order_status_id'], $dataSet['SMSkaleyra']['OrderStatusChange']['OrderStatus'])))) {
	            if(isset($order_info['order_status'])) {
	                $Status = $order_info['order_status'];
	            } else {
	                    $Status = "";
	            }
	                    $language 		= $order_info['language_id'];
	                    $last_order_status = $this->model_app->getLastOrderStatuses($order_id,$language);
	                    
	                    $Status1 =      !empty($last_order_status[1]['name']) ? $last_order_status[1]['name'] : '';	                    
	                    $Status2 =      $Status;
	                    $original		= array("{SiteName}","{OrderID}","{Status}","{Status1}","{Status2}","{StatusFrom}","{StatusTo}");
	                    $replace		= array($this->config->get('config_name'), $order_id, $Status,$Status1,$Status2,$Status1, $Status2);
	                    
	                    $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['OrderStatusChangeText'][$language]);
	                    $phone = $order_info['telephone'];
	                    
	                    if(is_array($message)) {
	                        $message = implode("','",$message);
	                    }
	                    
	                    $sendCheck = $this->model_app->CheckNumberCat($phone);
	                    $from = '';
	                    
	                    if (isset($dataSet['SMSkaleyra']['listsenderstore'])) {
	                        $fromset = $dataSet['SMSkaleyra']['listsenderstore'];
	                        foreach($fromset as $froms) {
	                            $from = $froms;
	                        }
	                        
	                    } 
	                    
	                    if(isset($dataSet['SMSkaleyra']['unicode-text-customer-order-status-change'][$language]) && $dataSet['SMSkaleyra']['unicode-text-customer-order-status-change'][$language] == 1){
	                        $unicode = 1;
	                    } else {
	                        $unicode = 0;
	                    }
	                    
	                    if ($sendCheck) {
	                        $resultreturn =  $sendsms->sendSMS(array(
	                            'SID' => $dataSet['SMSkaleyra']['SID'],
	                            'sender' => $from,
	                            'to' => $sendCheck,
	                            'api-key' => $dataSet['SMSkaleyra']['APIKey'],
	                            'body' => $message,
	                      //      'callback' => array($this->model_class, 'Callback')
	                            'type' => $dataSet['SMSkaleyra']['Type'],
	                            'unicode' => $unicode,
	                        ));
	                        
	                        $this->Insertdb($resultreturn);
	                    }
	        }
	    }
	  
	}
	
	//Send SMS new order

	public function successCheckoutkaleyra($data = 0) {

      	if (isset($this->session->data['order_id'])) {        	
           $order_id = $this->session->data['order_id'];
        } else {
            $order_id = 0;
        } 

        
		if ($order_id != 0 && version_compare(VERSION,'2.3.0.1', '>')) {

		    // setting opencart	    
		    
		    $this->load->model('checkout/order');
		    $order_info = $this->model_checkout_order->getOrder($order_id);

		    $this->load->model('setting/setting');
		    $dataSet = $this->model_setting_setting->getSetting('SMSkaleyra', $order_info['store_id']);

		    if(strcmp(VERSION,"2.1.0.1") < 0) {
		        $this->load->library('smskaleyra');
		    }
		    
		    if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey']))) {
		        $sendsms = new SmsKaleyra($dataSet['SMSkaleyra']['APIKey']);
		    }
		    
		    //Send SMS - customer
		    
		    $from = '';
		    
		    if (isset($dataSet['SMSkaleyra']['listsenderstore'])) {
		        $fromset = $dataSet['SMSkaleyra']['listsenderstore'];
		        foreach($fromset as $froms) {
		            $from = $froms;
		        }
		        
		    } 
		    
		    if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['CustomerPlaceOrder']['Enabled'] == 'yes')) {
        
		        if (!empty($order_info['telephone'])) {
		            $phone = $order_info['telephone'];
		        } else {
		            $phone = '';
		        }
		        $language 		= $this->config->get('config_language_id');
		        if ($order_info['payment_address_format']) {
		            $format = $order_info['payment_address_format'];
		        } else {
		            $format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
		        }
		        
		        $find = array(
		            '{firstname}',
		            '{lastname}',
		            '{company}',
		            '{address_1}',
		            '{address_2}',
		            '{city}',
		            '{postcode}',
		            '{zone}',
		            '{zone_code}',
		            '{country}'
		        );
		        
		        $replace = array(
		            'firstname' => $order_info['payment_firstname'],
		            'lastname'  => $order_info['payment_lastname'],
		            'company'   => $order_info['payment_company'],
		            'address_1' => $order_info['payment_address_1'],
		            'address_2' => $order_info['payment_address_2'],
		            'city'      => $order_info['payment_city'],
		            'postcode'  => $order_info['payment_postcode'],
		            'zone'      => $order_info['payment_zone'],
		            'zone_code' => $order_info['payment_zone_code'],
		            'country'   => $order_info['payment_country']
		        );
		        
		        $payment_address = str_replace($find, $replace, $format);
		        
		        if ($order_info['shipping_address_format']) {
		            $format = $order_info['shipping_address_format'];
		        } else {
		            $format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
		        }
		        
		        $find = array(
		            '{firstname}',
		            '{lastname}',
		            '{company}',
		            '{address_1}',
		            '{address_2}',
		            '{city}',
		            '{postcode}',
		            '{zone}',
		            '{zone_code}',
		            '{country}'
		        );
		        
		        $replace = array(
		            'firstname' => $order_info['shipping_firstname'],
		            'lastname'  => $order_info['shipping_lastname'],
		            'company'   => $order_info['shipping_company'],
		            'address_1' => $order_info['shipping_address_1'],
		            'address_2' => $order_info['shipping_address_2'],
		            'city'      => $order_info['shipping_city'],
		            'postcode'  => $order_info['shipping_postcode'],
		            'zone'      => $order_info['shipping_zone'],
		            'zone_code' => $order_info['shipping_zone_code'],
		            'country'   => $order_info['shipping_country']
		        );
		        
		        $shipping_address = str_replace($find, $replace, $format);
		        
		        $original		= array(
		            "{OrderID}",
		            "{SiteName}",
		            "{CartTotal}",
		            "{ShippingAddress}",
		            "{ShippingMethod}",
		            "{PaymentAddress}",
		            "{PaymentMethod}"
		        );
		        
		        $replace		= array(
		            $order_id,
		            $this->config->get('config_name'),
		            $order_info['total'],
		            $shipping_address,
		            $order_info['shipping_method'],
		            $payment_address,
		            $order_info['payment_method']
		        );
		        
		        $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['CustomerPlaceOrderText'][$language]);
		        
		        if(is_array($message)) {
		            $message = implode("','",$message);
		        }
		        
		        $sendCheck = $this->model_app->CheckNumberCat($phone);
		        
		        if(isset($dataSet['SMSkaleyra']['unicode-text-customer-place-order'][$language]) && $dataSet['SMSkaleyra']['unicode-text-customer-place-order'][$language] == 1){
		            $unicode = 1;
		        } else {
		            $unicode = 0;
		        }
		        
		        if (!empty($phone) && $sendCheck) {
		        $resultreturn =   $sendsms->sendSMS(array(
		                'SID' => $dataSet['SMSkaleyra']['SID'],
		                'sender' => $from,
		                'to' => $sendCheck,
		                'api-key' => $dataSet['SMSkaleyra']['APIKey'],
		                'body' => $message,
		                'callback' => array('ModelModuleSmsKaleyra', 'Callback'),
		                'type' => $dataSet['SMSkaleyra']['Type'],
		                'unicode' => $unicode,
		            ));
		            
		            $this->session->data["klr_lastorder"]['time'] = date('m/d/Y h:i:s a', time());
		            $this->session->data["klr_lastorder"]['price'] = $order_info['total'];
		            
		            $this->Insertdb($resultreturn);
		            
		        }
		        
		    }
		    
		    //Send SMS - admin
		    if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['AdminPlaceOrder']['Enabled'] == 'yes')) {
		        
		        if ($order_info['order_status_id'] != 0) {
		            if (!empty($order_info['telephone'])) {
		                $phone = $order_info['telephone'];
		            } else {
		                $phone = '';
		            }
		            $language 		= $this->config->get('config_language_id');
		            $original		= array("{OrderID}","{SiteName}","{CartTotal}");
		            $replace		= array($order_id, $this->config->get('config_name'),$order_info['total']);
		            
		            $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['AdminPlaceOrderText']);
		            
		            if(is_array($message)) {
		                $message = implode("','",$message);
		            }
		            
		               
		            $store_info = $this->model_setting_setting->getSetting('config', $this->config->get('store_id'));
		            $phone = $store_info['config_telephone'];
		            
		            $sendCheck = $this->model_app->CheckNumberCat($phone);
		            
		            if(isset($dataSet['SMSkaleyra']['unicode-text-admin-order-placed'][$language]) && $dataSet['SMSkaleyra']['unicode-text-admin-order-placed'][$language] == 1){
		                $unicode = 1;
		            } else {
		                $unicode = 0;
		            }
		            
		            if (!empty($phone)) {
		                $resultreturn = $sendsms->sendSMS(array(
		                        'SID' => $dataSet['SMSkaleyra']['SID'],
		                        'sender' => $from,
		                        'to' => $sendCheck,
		                        'api-key' => $dataSet['SMSkaleyra']['APIKey'],
		                        'body' => $message,
		                        'callback' => array('ModelModuleSmsKaleyra', 'Callback'),
		                        'type' => $dataSet['SMSkaleyra']['Type'],
		                        'unicode' => $unicode,
		                    ));
		                
		                $this->Insertdb($resultreturn);
		                }		           
		          }
		    }
	    
		}

    }

    public function returnAddtkaleyra($origin, $route = '', $data = '') {
    
        
        if (version_compare(VERSION, '2.2.0.0', ">=") && version_compare(VERSION, '2.3.0.0', "<")) {
            $order_id = $data;
        } else if(version_compare(VERSION, '2.3.0.0', ">=")){
            $order_id = $route[0]['order_id'];
        }
                
                  // setting opencart
            
            $this->load->model('account/order');
            $order_info = $this->model_account_order->getOrder($order_id);
    
            
            $this->load->model('setting/setting');
            $dataSet = $this->model_setting_setting->getSetting('SMSkaleyra', $order_info['store_id']);
            
            if(strcmp(VERSION,"2.1.0.1") < 0) {
                $this->load->library('smskaleyra');
            }
            
            if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey']))) {
                $sendsms = new SmsKaleyra($dataSet['SMSkaleyra']['APIKey']);
            }

            
        if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['AdminModOrder']['Enabled'] == 'yes')) {
            
            if ($order_info['order_status_id'] != 0) {
                if (!empty($order_info['telephone'])) {
                    $phone = $order_info['telephone'];
                } else {
                    $phone = '';
                }
                $language 		= $this->config->get('config_language_id');
                $original		= array("{OrderID}","{SiteName}","{CustomerName}");
                $replace		= array($order_id, $this->config->get('config_name'),$order_info['firstname'].''.$order_info['lastname']);
                
                $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['AdminModorderText']);
                
                if(is_array($message)) {
                    $message = implode("','",$message);
                }
                
                
                $store_info = $this->model_setting_setting->getSetting('config', $this->config->get('store_id'));
                $phone = $store_info['config_telephone'];
                
                $sendCheck = $this->model_app->CheckNumberCat($phone);
                
                $from = '';
                
                if (isset($dataSet['SMSkaleyra']['listsenderstore'])) {
                    $fromset = $dataSet['SMSkaleyra']['listsenderstore'];
                    foreach($fromset as $froms) {
                        $from = $froms;
                    }
                    
                }
                
                if(isset($dataSet['SMSkaleyra']['unicode-text-admin-on-modorder'][$language]) && $dataSet['SMSkaleyra']['unicode-text-admin-on-modorder'][$language] == 1){
                    $unicode = 1;
                } else {
                    $unicode = 0;
                }
                
                
                if (!empty($phone)) {
                    $resultreturn = $sendsms->sendSMS(array(
                        'SID' => $dataSet['SMSkaleyra']['SID'],
                        'sender' => $from,
                        'to' => $sendCheck,
                        'api-key' => $dataSet['SMSkaleyra']['APIKey'],
                        'body' => $message,
                        'callback' => array('ModelModuleSmsKaleyra', 'Callback'),
                        'type' => $dataSet['SMSkaleyra']['Type'],
                        'unicode' => $unicode,
                    ));
                    
                    $this->Insertdb($resultreturn);
                }
            }
        }
    //    exit();
    }

    // registration affiliate 
    public function addAffiliatekaleyra() {
        
               
        if (func_num_args() > 1) {
            $temp_id = !is_array(func_get_arg(1)) ? func_get_arg(1) : func_get_arg(2);
        } else {
            $temp_id = func_get_arg(0);
        }
        
        $affilate_id = $temp_id;
        
        $this->load->model('setting/setting');
        $dataSet = $this->model_setting_setting->getSetting('SMSkaleyra', $this->config->get('store_id'));
        
        if(strcmp(VERSION,"2.1.0.1") < 0) {
            $this->load->library('smskaleyra');
        }
        if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey']))) {
            $sendsms = new SmsKaleyra($dataSet['SMSkaleyra']['APIKey']);
        }
        
        $language 		= $this->config->get('config_language_id');
        
        //Send SMS to the admin when new affiale
        if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['AdminAffiliateRegister']['Enabled'] == 'yes')) {
            $affilate= $this->model_app->DataAffilate($affilate_id);
            
            if ($affilate->row) {
                $nameAffilate = $affilate->row['firstname']." ".$affilate->row['lastname'];
            } else {
                $nameAffilate = '';
            }
            
            $original		= array("{StoreName}","{AffiliateName}");
            $replace		= array($this->config->get('config_name'), $nameAffilate);
            
            $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['AffiliateRegisterAdminText']);
            
            if(is_array($message)) {
                $message = implode("','",$message);
            }
            
            $from = '';
            if (isset($dataSet['SMSkaleyra']['listsenderstore'])) {
                $fromset = $dataSet['SMSkaleyra']['listsenderstore'];
                foreach($fromset as $froms) {
                    $from = $froms;
                }
                
            }
            $store_info = $this->model_setting_setting->getSetting('config', $this->config->get('store_id'));
            $phone = $store_info['config_telephone'];
            
            
            if(isset($dataSet['SMSkaleyra']['unicode-text-affiliate-register-admin'][$language]) && $dataSet['SMSkaleyra']['unicode-text-affiliate-register-admin'][$language] == 1){
                $unicode = 1;
            } else {
                $unicode = 0;
            }
            
            $sendCheck = $this->model_app->CheckNumberCat($phone);
            if (!empty($phone)) {
                $resultreturn = $sendsms->sendSMS(array(
                    'SID' => $dataSet['SMSkaleyra']['SID'],
                    'api-key' => $dataSet['SMSkaleyra']['APIKey'],
                    'sender' => $from,
                    'to' => $sendCheck,
                    'body' => $message,
    //              'callback' => array($this->model_class, 'Callback')
                    'type' => $dataSet['SMSkaleyra']['Type'],
                    'unicode' => $unicode,
                ));
                
                $this->Insertdb($resultreturn);
            }
            
        }
        

        //Send SMS to the Affiliate for registration it's ok
        if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['AffiliateRegister']['Enabled'] == 'yes')) {
            $affilate= $this->model_app->DataAffilate($affilate_id);
            
            if ($affilate->row) {
                $phone = $affilate->row['telephone'];
                $nameAffilate = $affilate->row['firstname']." ".$affilate->row['lastname'];
            } else {
                $phone = '';
                $nameAffilate = '';
            }
            
            
            $original		= array("{StoreName}","{AffiliateName}");
            $replace		= array($this->config->get('config_name'), $nameAffilate);
            
            $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['AffiliateRegisterText'][$language]);
            
            if(is_array($message)) {
                $message = implode("','",$message);
            }
            
            $sendCheck = $this->model_app->CheckNumberCat($phone);
            $from = '';
            
            if (isset($dataSet['SMSkaleyra']['listsenderstore'])) {
                $fromset = $dataSet['SMSkaleyra']['listsenderstore'];
                foreach($fromset as $froms) {
                    $from = $froms;
                }
                
            }
            
            if(isset($dataSet['SMSkaleyra']['unicode-text-affiliate-register'][$language]) && $dataSet['SMSkaleyra']['unicode-text-affiliate-register'][$language] == 1){
                $unicode = 1;
            } else {
                $unicode = 0;
            }
            
            if ($sendCheck) {
                $resultreturn = $sendsms->sendSMS(array(
                    'SID' => $dataSet['SMSkaleyra']['SID'],
                    'sender' => $from,
                    'to' => $sendCheck,
                    'api-key' => $dataSet['SMSkaleyra']['APIKey'],
                    'body' => $message,
         //         'callback' => array($this->model_class, 'Callback')
                    'type' => $dataSet['SMSkaleyra']['Type'],
                    'unicode' => $unicode,
                ));
                
                $this->Insertdb($resultreturn);
            }
        }
 //   exit();
    }
    
    public function alertStockkaleyra($data = 0) {
        
        if (isset($this->session->data['order_id'])) {
            $order_id = $this->session->data['order_id'];
        } else {
            $order_id = 0;
        }
        
        
        if ($order_id != 0 && version_compare(VERSION,'2.3.0.1', '>')) {
            
            // setting opencart
            
            $this->load->model('checkout/order');
            $order_info = $this->model_checkout_order->getOrder($order_id);
            
            $this->load->model('setting/setting');
            $dataSet = $this->model_setting_setting->getSetting('SMSkaleyra', $order_info['store_id']);
            
            if(strcmp(VERSION,"2.1.0.1") < 0) {
                $this->load->library('smskaleyra');
            }
            
            if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey']))) {
                $sendsms = new SmsKaleyra($dataSet['SMSkaleyra']['APIKey']);
            }
         $productStock =   $this->model_app->alertStock($order_id); 
         
         if(is_array($productStock) && !empty($productStock)){
             foreach ($productStock as $arraystock){
                 $stockarr[] = $arraystock['product_id'];
             }
             
             $Stockstr = implode("','",$stockarr);
             $Stockstr = str_replace("'","",$Stockstr);
         }
      
            //Send SMS - admin
         if(isset($dataSet) && (!empty($dataSet['SMSkaleyra']['APIKey'])) && ($dataSet['SMSkaleyra']['AdminStock']['Enabled'] == 'yes') && !empty($productStock)) {
                
                if ($order_info['order_status_id'] != 0) {
                    if (!empty($order_info['telephone'])) {
                        $phone = $order_info['telephone'];
                    } else {
                        $phone = '';
                    }
                
                    $language 		= $this->config->get('config_language_id');
                    $original		= array("{ProductID}");
                    $replace		= array($Stockstr);
                    
                    $message = str_replace($original, $replace, $dataSet['SMSkaleyra']['AdminStockText']);
                    
                    if(is_array($message)) {
                        $message = implode("','",$message);
                    }
                    
                
                    $store_info = $this->model_setting_setting->getSetting('config', $this->config->get('store_id'));
                    $phone = $store_info['config_telephone'];
                    
                    $sendCheck = $this->model_app->CheckNumberCat($phone);
                    
                    $from = '';
                    if (isset($dataSet['SMSkaleyra']['listsenderstore'])) {
                        $fromset = $dataSet['SMSkaleyra']['listsenderstore'];
                        foreach($fromset as $froms) {
                            $from = $froms;
                        }
                        
                    }
                    
                    if(isset($dataSet['SMSkaleyra']['unicode-text-admin-on-stock'][$language]) && $dataSet['SMSkaleyra']['unicode-text-admin-on-stock'][$language] == 1){
                        $unicode = 1;
                    } else {
                        $unicode = 0;
                    }
                    
                    if (!empty($phone)) {
                        $resultreturn = $sendsms->sendSMS(array(
                            'SID' => $dataSet['SMSkaleyra']['SID'],
                            'sender' => $from,
                            'to' => $sendCheck,
                            'api-key' => $dataSet['SMSkaleyra']['APIKey'],
                            'body' => $message,
                            'callback' => array('ModelModuleSmsKaleyra', 'Callback'),
                            'type' => $dataSet['SMSkaleyra']['Type'],
                            'unicode' => $unicode,
                        ));
                        
                        $this->Insertdb($resultreturn);
                    }
                }
            }
            
     //      exit();
        }
        
    }
    
    
    public function Insertdb($dataresult){
        
        if(isset($dataresult['id'])) {  // gest error
            $data = array();
            $data['id_hexa']         = $dataresult['id'];
            $data['sender']          = $dataresult['sender'];
            $data['type']            = $dataresult['type'];
            $data['body']            = $dataresult['body'];
            $data['createdDateTime'] = $dataresult['createdDateTime'];
            $data['recipient']       = $dataresult['data'][0]['recipient'];
            $data['message_id']      = $dataresult['data'][0]['message_id'];
            
            $send_id = $this->model_app->InsertSendSMS($data);
        } else {
            $this->writeLog("sms_result_log.txt", $dataresult);
        }
        
    }
    
    public function writeLog($filename,$message) {
        
        $this->handle = fopen(DIR_LOGS . $filename, 'a');
        fwrite($this->handle, print_r($message, true) . "\n");
        fclose($this->handle);
    }
  

    private function log($text) {
		$log = new Log("sms_error_log_kaleyra.txt");
		$log->write($text);	
	}
}